/* Inspired by https://github.com/justincy/fsTreeSearch */

$(document).ready(function(){  
  if ( window.location.pathname.substring(0,33) == '/personen-zoeken/zoeken/document/' ) 
  {
		topic=getTopic();		
		addGedcom( topic.sourcetype );
		showGo( topic.firstnames, topic.lastname );
		showGw (topic.lastname);
		addWzw( topic.lastname );
 	}
});


/* Unfortunatly no semantic markup on WieWasWie, so some tricky splitting to get parts we want: sourcetype, firstnames and lastname, this is by no means fool-proof! The GEDCOM conversion routines has the same problem with identifing firstnames and lastname. */

function getTopic() 
{
	arrHead=$("h1:first").text().split(/met /);
	
	strSourcetype=arrHead[0].trim();
	arrName=arrHead[1].trim();
	arrParts=arrName.split(/  /);
	if (arrParts.length==2) {				// some firstnames/lastname seem to be diveded by 2 or 3 spaces
		strFirstname=arrParts[0].trim();
		strLastname=arrParts[1].trim();
	} else {												// while other don't, so no real way to distinguish firstnames and lastname, sigh
		strFirstname="";
		strLastname=arrName.split(/[\s-]/).pop();
	}		
		
	return {"sourcetype":strSourcetype,"firstnames":arrParts[0].trim(),"lastname":strLastname }
}


/* Show simple link to search functionality of Genealogie Online with firstname(s) and lastname as parameters. */

function showGo(strFirstnames,strLastname) 
{
	srcGoImg=chrome.extension.getURL("images/go.gif");
	$('<li><a target="go" href="https://www.genealogieonline.nl/zoeken/index.php?gw=wx&q='+encodeURIComponent(strLastname)+'&vn='+encodeURIComponent(strFirstnames)+'"><img src="'+srcGoImg+'" class="extIcon">Zoek persoon op Genealogie Online</a></li>').appendTo('#cphBody_cphBody_sourceMenu');
}


/* Show pull down list of other genealogical search engines which are searchable by familyname. This uses the services of http://www.genealogiewerkbalk.nl/ */

function showGw(strLastname)
{
	srcGwImg=chrome.extension.getURL("images/gw.gif");
	$('<li><form id="gw" action="https://www.genealogiewerkbalk.nl/plusgenealogie/gw-redirector.php?bron=mr&q=coret" target="gw" method="get"><input type="hidden" name="q" value="'+strLastname+'"/><select name="bron" title="Selecteer een andere genealogische bron die u wilt doorzoeken, deze opent in een nieuw scherm. Dit een service van de Genealogie Werkbalk." id="se"><option>Doorzoek andere site...</option><option value="go">Genealogie Online</option><option value="sg">Stamboom Gids</option><option value="sf">Stamboom Forum</option><option value="wz">Wie (onder)zoekt wie?</option><option value="af">Alle Friezen</option><option value="ag">Alle Groningers</option><option value="ar">Archieven.nl</option><option value="bh">BHIC</option><option value="cb">Centraal Bureau Genealogie</option><option value="cd">Contactdienst</option><option value="ds">Digitale Stamboom</option><option value="dr">Drenlias</option><option value="na">GaHetNa</option><option value="gn">Geneanet Nederland</option><option value="gt">Graftombe</option><option value="gh">Groene Hart Archieven</option><option value="kb">Krantencollectie KB</option><option value="ml">Mensenlinq</option><option value="mr">Militieregisters</option><option value="nf"> Familienamen Databank</option>><option value="mu">Mundia</option><option value="ob">Online begraafplaatsen</option><option value="of">Online familieberichten</option><option value="rk">Regionaal Archief Alkmaar</option><option value="rn">Regionaal Archief Nijmegen</option><option value="rt">Regionaal Archief Tilburg</option><option value="ra">Regionaal Archief West-Brabant</option><option value="os">Oorlogsgravenstichting</option><option value="sn">Stambomen NGV</option><option value="sz">Stamboomzoeker</option><option value="us">Uw Stamboom Online</option><option value="zg">Zeeuwen gezocht</option></select><input type="button" class="zbtn" value="" onclick="getElementById(\'gw\').submit();"></form><a id="gwicon" target="gw" href="http://www.genealogiewerkbalk.nl/"><img src="'+srcGwImg+'" class="extIcon"></a></li>').appendTo('#cphBody_cphBody_sourceMenu');
}


/* Show download link with certain sourcetypes, the link has part of the content (compressed) which is translated to GEDCOM server-side. */

var arrGedcomSourcetypes=[ "BS Overlijden","BS Geboorte","BS Huwelijk","DTB Dopen","DTB Trouwen","DTB Begraven" ];
        
function addGedcom(strSourcetype) 
{
	if (jQuery.inArray(strSourcetype, arrGedcomSourcetypes) > -1) {
		showGedcom();
	}
}

function showGedcom() 
{
		data=strDeflate( $(".content.akte").html() );
		$('<li><a id="gedcom" href="#"><span class="downloadicon">&nbsp;</span> Download als GEDCOM</a></li>').appendTo('#cphBody_cphBody_sourceMenu');	
		$("#gedcom").attr("onclick","openPopup('https://www.genealogiewerkbalk.nl/plusgenealogie/gedcom.php?data="+encodeURIComponent(data).replace("'","%27")+";',$('#gedcom'),350,114)");
}


/* Because the data is transmitted as GET request the garbage has to be removed from the HTML part */
	
function strDeflate(str) 
{
  str=str.replace(/\n/gm,"");
  str=str.replace(/\r/gm,"");

	str=str.replace(/\<span\>\<span class=\"icon .*?\"\>.*?\<\/span\>(.*?) afbeelding\<\/span\>/gm,"<$1Afbeelding|Ja>");
	str=str.replace(/\<div class\=\"disclaimer printonly\"\>.*?\>(.*?)\<\/a\>/m,"<URL|$1>");
	
  str=str.replace(/<div .*?>/gm,"");
  str=str.replace(/<\/div>/gm,"");
  str=str.replace(/<dl .*?>/gm,"");
  str=str.replace(/<\/dl>/gm,"");
  str=str.replace(/<strong>/gm,"");
  str=str.replace(/<\/strong>/gm,"");
  str=str.replace(/<span>/gm,"");
  str=str.replace(/<\/span>/gm,"");
  str=str.replace(/<a .*?>/gm,"");
  str=str.replace(/<\/a>/gm,"");
  str=str.replace(/<ul.*?>/gm,"");
  str=str.replace(/<\/ul>/gm,"");
  str=str.replace(/<li>/gm,"");
  str=str.replace(/<\/li>/gm,"");
  str=str.replace(/<dfn .*?>/gm,"");
  str=str.replace(/<\/dfn>/gm,"");
  str=str.replace(/<img .*?>/gm,"");
  str=str.replace(/ class="akt.*?"/gm,"");
  str=str.replace(/:<\/dt><dd>/gm,"|");
	str=str.replace(/<dt>/gm,"<");
  str=str.replace(/<\/dd>/gm,">");
  str=str.replace(/\s{4,10}/gm,"");
	
	return str.trim();
}


/* Search Who (re)searches Who? register for lastname via JSONP call, if people research lastname show link to register with number of hits (see http://api.coret.org/wiezoektwie/) */

function addWzw(strLastname) 
{
	$.getJSON('https://api.coret.org/wiezoektwie/aantal/v1/?q='+encodeURIComponent(strLastname)+'&output=json&search=starts', function(data) { 
		if (data.Coret.WieZoektWie.Aantal>0) { showWzw(data.Coret.WieZoektWie.Aantal,data.Coret.WieZoektWie.Url.Zoeken,strLastname); } }
	);
}

function showWzw(nrResearchers,strUrl,strLastname) 
{
	srcSfImg=chrome.extension.getURL("images/sf.gif");
	$('<li><a target="sf" href="'+strUrl+'"><img src="'+srcSfImg+'" class="extIcon">De naam '+capitaliseFirstLetter(strLastname)+' komt <span class="wzwaantal">'+nrResearchers+'</span> keer voor in het Wie(onder)zoekt wie? register</a></li>').appendTo('#cphBody_cphBody_sourceMenu');
}

function capitaliseFirstLetter(string)
{
    return string.charAt(0).toUpperCase() + string.slice(1);
}